package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.WXAccount;

/**
 * 实体[WXEntApp] 数据对象
 */
@TableName(value = "T_SRFWXENTAPP",resultMap = "WXEntAppResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WXEntApp extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WXAccount wxaccount;
    private Integer agentid;
    private String apiappsecret;
    private String apiencodingaeskey;
    private String apitoken;
    private String apiurl;
    @Dict(dictName = "ionicdemo_WXEntAppTypeCodeList")
    private String apptype;
    private String appurl;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String memo;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer repenterflag;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer replocationflag;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer validflag;
    private String wxaccountid;
    @TableField(exist = false)//逻辑属性
    private String wxaccountname;
    @TableId(value= "wxentappid",type=IdType.UUID)//指定主键生成策略
    private String wxentappid;
    private String wxentappname;
    /**
     *  设置属性值[应用标识]
     *  @param agentid
     */
    public void setAgentid(Integer agentid){
        this.agentid = agentid;
        this.set("agentiddirtyflag",true);
    }
    /**
     *  获取属性值[应用标识]
     */
    public Integer getAgentid(){
        return this.agentid;
    }
    /**
     *  重置属性值[应用标识]
     */
    public void resetAgentid(){
        this.set("agentiddirtyflag",false);
        this.agentid = null;
    }
    /**
     *  设置属性值[AppSecret]
     *  @param apiappsecret
     */
    public void setApiappsecret(String apiappsecret){
        if(StringUtils.isEmpty(apiappsecret))
            apiappsecret=null;
        this.apiappsecret = apiappsecret;
        this.set("apiappsecretdirtyflag",true);
    }
    /**
     *  获取属性值[AppSecret]
     */
    public String getApiappsecret(){
        return this.apiappsecret;
    }
    /**
     *  重置属性值[AppSecret]
     */
    public void resetApiappsecret(){
        this.set("apiappsecretdirtyflag",false);
        this.apiappsecret = null;
    }
    /**
     *  设置属性值[APIENCODINGAESKEY]
     *  @param apiencodingaeskey
     */
    public void setApiencodingaeskey(String apiencodingaeskey){
        if(StringUtils.isEmpty(apiencodingaeskey))
            apiencodingaeskey=null;
        this.apiencodingaeskey = apiencodingaeskey;
        this.set("apiencodingaeskeydirtyflag",true);
    }
    /**
     *  获取属性值[APIENCODINGAESKEY]
     */
    public String getApiencodingaeskey(){
        return this.apiencodingaeskey;
    }
    /**
     *  重置属性值[APIENCODINGAESKEY]
     */
    public void resetApiencodingaeskey(){
        this.set("apiencodingaeskeydirtyflag",false);
        this.apiencodingaeskey = null;
    }
    /**
     *  设置属性值[Token]
     *  @param apitoken
     */
    public void setApitoken(String apitoken){
        if(StringUtils.isEmpty(apitoken))
            apitoken=null;
        this.apitoken = apitoken;
        this.set("apitokendirtyflag",true);
    }
    /**
     *  获取属性值[Token]
     */
    public String getApitoken(){
        return this.apitoken;
    }
    /**
     *  重置属性值[Token]
     */
    public void resetApitoken(){
        this.set("apitokendirtyflag",false);
        this.apitoken = null;
    }
    /**
     *  设置属性值[API地址]
     *  @param apiurl
     */
    public void setApiurl(String apiurl){
        if(StringUtils.isEmpty(apiurl))
            apiurl=null;
        this.apiurl = apiurl;
        this.set("apiurldirtyflag",true);
    }
    /**
     *  获取属性值[API地址]
     */
    public String getApiurl(){
        return this.apiurl;
    }
    /**
     *  重置属性值[API地址]
     */
    public void resetApiurl(){
        this.set("apiurldirtyflag",false);
        this.apiurl = null;
    }
    /**
     *  设置属性值[应用类型]
     *  @param apptype
     */
    public void setApptype(String apptype){
        if(StringUtils.isEmpty(apptype))
            apptype=null;
        this.apptype = apptype;
        this.set("apptypedirtyflag",true);
    }
    /**
     *  获取属性值[应用类型]
     */
    public String getApptype(){
        return this.apptype;
    }
    /**
     *  重置属性值[应用类型]
     */
    public void resetApptype(){
        this.set("apptypedirtyflag",false);
        this.apptype = null;
    }
    /**
     *  设置属性值[应用路径]
     *  @param appurl
     */
    public void setAppurl(String appurl){
        if(StringUtils.isEmpty(appurl))
            appurl=null;
        this.appurl = appurl;
        this.set("appurldirtyflag",true);
    }
    /**
     *  获取属性值[应用路径]
     */
    public String getAppurl(){
        return this.appurl;
    }
    /**
     *  重置属性值[应用路径]
     */
    public void resetAppurl(){
        this.set("appurldirtyflag",false);
        this.appurl = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[是否进入应用]
     *  @param repenterflag
     */
    public void setRepenterflag(Integer repenterflag){
        this.repenterflag = repenterflag;
        this.set("repenterflagdirtyflag",true);
    }
    /**
     *  获取属性值[是否进入应用]
     */
    public Integer getRepenterflag(){
        return this.repenterflag;
    }
    /**
     *  重置属性值[是否进入应用]
     */
    public void resetRepenterflag(){
        this.set("repenterflagdirtyflag",false);
        this.repenterflag = null;
    }
    /**
     *  设置属性值[是否上报位置]
     *  @param replocationflag
     */
    public void setReplocationflag(Integer replocationflag){
        this.replocationflag = replocationflag;
        this.set("replocationflagdirtyflag",true);
    }
    /**
     *  获取属性值[是否上报位置]
     */
    public Integer getReplocationflag(){
        return this.replocationflag;
    }
    /**
     *  重置属性值[是否上报位置]
     */
    public void resetReplocationflag(){
        this.set("replocationflagdirtyflag",false);
        this.replocationflag = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[是否启用]
     *  @param validflag
     */
    public void setValidflag(Integer validflag){
        this.validflag = validflag;
        this.set("validflagdirtyflag",true);
    }
    /**
     *  获取属性值[是否启用]
     */
    public Integer getValidflag(){
        return this.validflag;
    }
    /**
     *  重置属性值[是否启用]
     */
    public void resetValidflag(){
        this.set("validflagdirtyflag",false);
        this.validflag = null;
    }
    /**
     *  设置属性值[微信公众号]
     *  @param wxaccountid
     */
    public void setWxaccountid(String wxaccountid){
        if(StringUtils.isEmpty(wxaccountid))
            wxaccountid=null;
        this.wxaccountid = wxaccountid;
        this.set("wxaccountiddirtyflag",true);
    }
    /**
     *  获取属性值[微信公众号]
     */
    public String getWxaccountid(){
        return this.wxaccountid;
    }
    /**
     *  重置属性值[微信公众号]
     */
    public void resetWxaccountid(){
        this.set("wxaccountiddirtyflag",false);
        this.wxaccountid = null;
    }
    /**
     *  设置属性值[微信公众号]
     *  @param wxaccountname
     */
    public void setWxaccountname(String wxaccountname){
        if(StringUtils.isEmpty(wxaccountname))
            wxaccountname=null;
        this.wxaccountname = wxaccountname;
        this.set("wxaccountnamedirtyflag",true);
    }
    /**
     *  获取属性值[微信公众号]
     */
    public String getWxaccountname(){
        return this.wxaccountname;
    }
    /**
     *  重置属性值[微信公众号]
     */
    public void resetWxaccountname(){
        this.set("wxaccountnamedirtyflag",false);
        this.wxaccountname = null;
    }
    /**
     *  设置属性值[微信企业应用标识]
     *  @param wxentappid
     */
    public void setWxentappid(String wxentappid){
        if(StringUtils.isEmpty(wxentappid))
            wxentappid=null;
        this.wxentappid = wxentappid;
        this.set("wxentappiddirtyflag",true);
    }
    /**
     *  获取属性值[微信企业应用标识]
     */
    public String getWxentappid(){
        return this.wxentappid;
    }
    /**
     *  重置属性值[微信企业应用标识]
     */
    public void resetWxentappid(){
        this.set("wxentappiddirtyflag",false);
        this.wxentappid = null;
    }
    /**
     *  设置属性值[微信企业应用名称]
     *  @param wxentappname
     */
    public void setWxentappname(String wxentappname){
        if(StringUtils.isEmpty(wxentappname))
            wxentappname=null;
        this.wxentappname = wxentappname;
        this.set("wxentappnamedirtyflag",true);
    }
    /**
     *  获取属性值[微信企业应用名称]
     */
    public String getWxentappname(){
        return this.wxentappname;
    }
    /**
     *  重置属性值[微信企业应用名称]
     */
    public void resetWxentappname(){
        this.set("wxentappnamedirtyflag",false);
        this.wxentappname = null;
    }
     /**
     *  获取主实体关联数据[WXAccount]
     */
    public WXAccount getWxaccount() {
        return wxaccount;
    }
    /**
     *  设置主实体关联数据[WXAccount]
     */
    public void setWxaccount(WXAccount wxaccount) {
        this.wxaccount = wxaccount;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetAgentid();
        resetApiappsecret();
        resetApiencodingaeskey();
        resetApitoken();
        resetApiurl();
        resetApptype();
        resetAppurl();
        resetCreatedate();
        resetCreateman();
        resetMemo();
        resetRepenterflag();
        resetReplocationflag();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetUpdatedate();
        resetUpdateman();
        resetValidflag();
        resetWxaccountid();
        resetWxaccountname();
        resetWxentappid();
        resetWxentappname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WXEntApp copyTo(WXEntApp targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WXEntApp.class, WXEntApp.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWxentappid();
		return targetEntity;
	}
}